local mapMod = foundation.createMod();

mapMod:registerAssetId("maps/heightmap_ninglor.png", "HEIGHT_MAP")
mapMod:registerAssetId("maps/material_mask_ninglor.png", "MATERIAL_MASK")
mapMod:registerAssetId("maps/coniferous_density.png", "CONIFEROUS_DENSITY_MAP")
mapMod:registerAssetId("maps/deciduous_density.png", "DECIDUOUS_DENSITY_MAP")
mapMod:registerAssetId("maps/berries_density.png", "BERRIES_DENSITY_MAP")
mapMod:registerAssetId("maps/rock_density.png", "ROCK_DENSITY_MAP")
mapMod:registerAssetId("maps/fish_density.png", "FISH_DENSITY_MAP")

-- Register Custom Map
mapMod:register({
	DataType = "CUSTOM_MAP",
	Id = "MAP_N_01",
	HeightMap = "HEIGHT_MAP",
	MaterialMask = "MATERIAL_MASK",
	MinHeight = -6,
	MaxHeight = 120,
	VillagePathList = {
		{
			Entrance = { 13, 41, 404 },
			Exit = { 13, 41, 404 }
		},
		{
			Entrance = { 835, 2, 13 },
			Exit = { 835, 2, 13 }
		},
		{
			Entrance = { 49, 33, 395 },
			Exit = { 49, 33, 395}
		},
	},
	SpawnList = {
	    {-- creating Mineral Deposit 1
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 694, 0, 648 }, Orientation = { 0 , 157 , 0 }, Scale = {1.3 ,1.5 ,1.5 },},
		{-- creating Mineral Deposit 2
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 731, -3, 665 }, Orientation = { 0 , 130 , 0 }, Scale = {1.5 ,1.85 ,1.5 },},
		{-- creating Mineral Deposit 3
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 717, -6, 657 }, Orientation = { 0 , 161 , 0 }, Scale = {1.4 ,2.5 ,1.5 },},
		{-- creating Mineral Deposit 4
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 681, 0, 640 }, Orientation = { 0 , -153 , 0 }, Scale = {1.5 ,1 ,1.3 },},
		{-- creating Mineral Deposit 5
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 706, -3, 647 }, Orientation = { 0 , 157 , 0 }, Scale = {1.4 ,1.2 ,1.4 },},
		{-- creating Mineral Deposit 6
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 728, -2, 653 }, Orientation = { 0 , 139 , 0 }, Scale = {1.5 ,1.6 ,1.3 },},
		{-- creating Mineral Deposit 7
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 743, -4, 670 }, Orientation = { 0 , 116 , 0 }, Scale = {1.2 ,1.5 ,1.4 },},
		{-- creating Mineral Deposit 8
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 751, 0, 683 }, Orientation = { 0 , 125 , 0 }, Scale = { 1, 1.2, 1 },},
		{-- creating Mineral Deposit 9
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 562, 4, 598 }, Orientation = { 0 , -157 , 0 }, Scale = { 1.2, 1, 1.1 },},
		{-- creating Mineral Deposit 10
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 559, 2, 531 }, Orientation = { 0 , 62 , 0 }, Scale = { 1.5, 1.2, 1 },},
		{-- creating Mineral Deposit 11
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 545, 1, 545 }, Orientation = { 0 , 59 , 0 }, Scale = { 1.3, 1.5, 1 },},
		{-- creating Mineral Deposit 12
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 766, 4, 258 }, Orientation = { 0 , -114 , 0 }, Scale = { 1, 1.2, 1 },},
		{-- creating Mineral Deposit 13
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 774, -2, 245 }, Orientation = { 0 , -139 , 0 }, Scale = { 1, 1.2, 1 },},
		{-- creating Mineral Deposit 14
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 757, 3, 267 }, Orientation = { 0 , -96 , 0 }, Scale = { 1.2, 1.2, 1.2 },},
		{-- creating Mineral Deposit 15
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 419, 16, 689 }, Orientation = { 0 , -5 , 0 }, Scale = { 1.5, 1, 1 },},
		{-- creating Mineral Deposit 16
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 406, 15, 683 }, Orientation = { 0 , -45 , 0 }, Scale = { 1.25, 1.3, 1 },},
		{-- creating Mineral Deposit 17
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 393, 15, 678 }, Orientation = { 0 , -31 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 18
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 338, 11, 391 }, Orientation = { 0 , -153 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 19
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 142, 1, 224 }, Orientation = { 0 , 147 , 0 }, Scale = { 1.5, 1.8, 1.5 },},
		{-- creating Mineral Deposit 20
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 157, -1, 231 }, Orientation = { 0 , 168 , 0 }, Scale = { 1.6, 1.8, 1.2 },},
		{-- creating Mineral Deposit 21
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 171, 2, 239 }, Orientation = { 0 , 135 , 0 }, Scale = { 1.2, 1.45, 1.2 },},
		{-- creating Mineral Deposit 22
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 191, -1, 240 }, Orientation = { 0 , 161 , 0 }, Scale = { 1.7, 1.7, 1 },},
		{-- creating Mineral Deposit 23
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 445, 1, 155 }, Orientation = { 0 , -45 , 0 }, Scale = { 1.6, 1.1, 0.9 },},
		{-- creating Mineral Deposit 24
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 61, 40, 496 }, Orientation = { 0 , 123 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 25
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 65, 31, 478 }, Orientation = { 0 , 65 , 0 }, Scale = { 1.5, 2.5, 1.3 },},
		{-- creating Mineral Deposit 26
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 79, 39, 469 }, Orientation = { 0 , 25 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 27
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 78, 28, 697 }, Orientation = { 0 , 96 , 0 }, Scale = { 1.5, 2, 1 },},
		{-- creating Mineral Deposit 28
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 77, 32, 677 }, Orientation = { 0 , 147 , 0 }, Scale = { 1.7, 1.3, 1 },},
		{-- creating Mineral Deposit 29
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 87, 30, 709 }, Orientation = { 0 , 66 , 0 }, Scale = { 1.5, 1, 1.5 },},
		{-- creating Mineral Deposit 30
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 140, 44, 961 }, Orientation = { 0 , 77 , 0 }, Scale = { 2.4, 2.4, 2.4 },},
		{-- creating Mineral Deposit 31
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 145, 48, 940 }, Orientation = { 0 , 124 , 0 }, Scale = {1.5 ,1.2 ,1 },},
		{-- creating Mineral Deposit 32
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 143, 46, 977 }, Orientation = { 0 , 55 , 0 }, Scale = {1.75 ,1.4 ,1.3 },},
		{-- creating Mineral Deposit 33
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 183, 48, 959 }, Orientation = { 0 , -101 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 34
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 182, 47, 934 }, Orientation = { 0 , -82 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 35
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 183, 51, 946 }, Orientation = { 0 , -92 , 0 }, Scale = { 1.5, 1, 1 },},
		{-- creating Mineral Deposit 36
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 246, 32, 910 }, Orientation = { 0 , -170 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 37
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 274, 30, 913 }, Orientation = { 0 , 137 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 38
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 262, 0, 913 }, Orientation = { 0 , 168 , 0 }, Scale = { 2.2, 4, 2.2 },},
		{-- creating Mineral Deposit 39
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 359, 10, 900 }, Orientation = { 0 , 130 , 0 }, Scale = { 1.2, 1, 1.2 },},
		{-- creating Mineral Deposit 40
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 496, 8, 935 }, Orientation = { 0 , -144 , 0 }, Scale = { 1.2, 1, 1 },},
		{-- creating Mineral Deposit 41
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 604, 0, 974 }, Orientation = { 0 , -149 , 0 }, Scale = { 1.4, 1.1, 1.4 },},
		{-- creating Mineral Deposit 42
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 613, 4, 968 }, Orientation = { 0 , 179 , 0 }, Scale = { 1, 1.3, 1 },},
		{-- creating Mineral Deposit 43
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 621, 4, 973 }, Orientation = { 0 , 140 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 44
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 612, -17, 985 }, Orientation = { 0 , -1 , 0 }, Scale = { 1.5, 3, 1.5 },},
		{-- creating Mineral Deposit 45
		Prefab = "PREFAB_MINERAL_SOURCE_3", Position = { 350, 16, 507 }, Orientation = { 0 , 0 , 0 }, Scale = { 1.3, 1, 1.3 },},
		{-- creating Mineral Deposit 46
	    Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 999, -2, 488 }, Orientation = { 0 , -83 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 47
		Prefab = "PREFAB_MINERAL_SOURCE_1", Position = { 985, 4, 299 }, Orientation = { 0 , -32 , 0 }, Scale = { 1, 1, 1 },},
		{-- creating Mineral Deposit 48
		Prefab = "PREFAB_MINERAL_SOURCE_2", Position = { 992, 7, 152 }, Orientation = { 0 , -89 , 0 }, Scale = { 1, 1, 1 },},
		},
	DensitySpawnList = {
		{
			-- Create forest of Deciduous trees and a few pine
			DensityMap = "DECIDUOUS_DENSITY_MAP",
			Density = 0.9,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_POPLAR" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.9, 0.8, 0.1, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_OAK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.9,
						Max = 1.9
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.9,
						Max = 1.9
					},
					ColorRange = {
						Min = { 0.0, 0.6, 0.4, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_SYCAMORE" },
					RandomWeight = 8,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.3, 0.4, 1 },
						Max = { 1, 1, 1, 1 }
					}
				},
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 1,
					OffsetSizeRange = {
						Min = 0.15,
						Max = 0.45
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.7,
						Max = 1
					},
					ColorRange = {
						Min = { 0.4, 0.1, 0.4, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
			{
			-- Create forest of Pine Trees
			DensityMap = "CONIFEROUS_DENSITY_MAP",
			Density = 0.8,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_TREE_PINE" },
					RandomWeight = 0.2,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.0, 0.45, 0.5, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create forest of berry bushes
			DensityMap = "BERRIES_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_BERRIES" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.917, 0.721, 0.101, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create rock outcrops - stone resource
			DensityMap = "ROCK_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_ROCK" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.729, 0.788, 0.811, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		},
		{
			-- Create fish shoals
			DensityMap = "FISH_DENSITY_MAP",
			Density = 1,
			PrefabConfigList = {
				{
					PrefabList = { "PREFAB_RESOURCE_FISH" },
					RandomWeight = 0.1,
					OffsetSizeRange = {
						Min = 0.75,
						Max = 1
					},
					OrientationRange = {
						Min = { 0, -180, 0},
						Max = { 0, 180, 0}
					},
					ScaleRange = {
						Min = 0.85,
						Max = 1.15
					},
					ColorRange = {
						Min = { 0.8, 0.8, 0.8, 1 },
						Max = { 1, 1, 1, 1 }
					}
				}
			}
		}
	}
})